/**
 * List templates.
 * @memberof module:apeman-tmpl/lib/templating
 * @function listTemplate
 * @returns {Promise}
 */

'use strict'

const ListLogger = require('../logging/list_logger')
const Promise = require('apemanpromise')
const getTemplates = require('./get_templates')

/** @lends listTemplate */
function listTemplate (configuration, names, callback) {
  let logger = new ListLogger({})

  let tmpls = getTemplates(configuration, names)
  let childTmpls = getTemplates.childTmpls(configuration, names)

  logger.logTemplates(tmpls, childTmpls)
  logger.logInstruction()
  return Promise.resolve(null)
}

module.exports = listTemplate
